@echo off

rem TestElevation.cmd
rem Written by Bill Stewart (bstewart@iname.com)
rem Part of the Elevation Toolkit package - test shell script for the IsElevated and Elevated utilities

setlocal enableextensions

rem Determine correct versions of IsElevated and Elevate tools.
if "%PROCESSOR_ARCHITECTURE%"=="x86" (
  set _ISELEVATED_EXE=%~dp0IsElevated32.exe
  set _ELEVATE_EXE=%~dp0Elevate32.exe
) else (
  set _ISELEVATED_EXE=%~dp0IsElevated64.exe
  set _ELEVATE_EXE=%~dp0Elevate64.exe
)

rem Exit script with an error if it can't find the tools.
if not exist "%_ISELEVATED_EXE%" (
  echo File not found - %_ISELEVATED_EXE%
  goto :DONE
)
if not exist "%_ELEVATE_EXE%" (
  echo File not found - %_ELEVATE_EXE%
  goto :DONE
)

rem Find out if we're currently running elevated.
"%_ISELEVATED_EXE%" -q
if %ERRORLEVEL% EQU 1 (
  echo Currently elevated: True
) else (
  echo Currently elevated: False
)

rem Run cmd.exe elevated and wait for it to complete.
"%_ELEVATE_EXE%" -w cmd.exe /k echo Elevation test script command prompt
if %ERRORLEVEL% EQU 1223 (
  echo Elevation request cancelled.
  goto :DONE
)
echo Exit code: %ERRORLEVEL%

:DONE
pause
endlocal
