' TestElevation.vbs
' Written by Bill Stewart (bstewart@iname.com)
' Part of the Elevation Toolkit package - test VBScript script for the IsElevated and Elevated utilities

Const ERROR_FILE_NOT_FOUND = 2
Const ERROR_CANCELLED      = 1223

Dim WshShell, FSO
Dim ScriptPath, Platform
Dim IsElevatedExe, ElevateExe
Dim IsElevated, Result

Set WshShell = CreateObject("WScript.Shell")
Set FSO = CreateObject("Scripting.FileSystemObject")

' Gets the current script's path.
ScriptPath = Left(WScript.ScriptFullName, Len(WScript.ScriptFullName) - Len(WScript.ScriptName))

' Determine the appropriate versions of IsElevated and Elevate.
Platform = WshShell.Environment("PROCESS").Item("PROCESSOR_ARCHITECTURE")
If Platform = "x86" Then
  IsElevatedExe = FSO.BuildPath(ScriptPath, "IsElevated32.exe")
  ElevateExe = FSO.BuildPath(ScriptPath, "Elevate32.exe")
Else
  IsElevatedExe = FSO.BuildPath(ScriptPath, "IsElevated64.exe")
  ElevateExe = FSO.BuildPath(ScriptPath, "Elevate64.exe")
End If

' Exit the script with an error if it can't find the IsElevated or Elevate programs.
If Not FSO.FileExists(IsElevatedExe) Then
  WScript.Echo "File not found - " & IsElevatedExe
  WScript.Quit ERROR_FILE_NOT_FOUND
End If
If Not FSO.FileExists(ElevateExe) Then
  WScript.Echo "File not found - " & ElevateExe
  WScript.Quit ERROR_FILE_NOT_FOUND
End If

' Find out whether we're currently running elevated.
IsElevated = WshShell.Run(IsElevatedExe & " -q", 0, True) = 1
WScript.Echo "Currently elevated: " & CStr(IsElevated)

' Run cmd.exe elevated and wait for it to complete.
Result = WshShell.Run(ElevateExe & " -w cmd.exe /k echo Elevation test script command prompt", 1, True)
If Result = ERROR_CANCELLED Then
  WScript.Echo "Elevation request cancelled."
  WScript.Quit Result
End If

WScript.Echo "Exit code: " & CStr(Result)
